<?php


namespace php;


use PaymentPlugins\PayPalSDK\Exception\AccessTokenExpiredException;
use PaymentPlugins\PayPalSDK\Exception\ApiException;

class AuthTest extends BaseTest {

	public function testFetchToken() {
		$client = $this->getClient();
		try {
			$token = $client->auth->create();

			return $this->assertIsObject( $token );
		} catch ( ApiException $e ) {
			return false;
		}
	}

	public function testExpiredAccessToken() {
		try {
			throw new AccessTokenExpiredException();
		} catch ( AccessTokenExpiredException $e ) {
			$token = $this->getClient()->auth->refresh();

			return $this->assertIsString( $token->access_token );
		}
	}
}