<?php


namespace php;


use PaymentPlugins\PayPalSDK\Client\BaseHttpClient;
use PaymentPlugins\PayPalSDK\PayPalClient;

class BaseTest extends \PHPUnit\Framework\TestCase {

	public function getClient() {
		$client = new PayPalClient( [
			'client_id'    => 'AbTnN_UDw-YbmMijIi1ZNj4lcPV8a9ECUWK4PU6MBSzr0yaAYHRLDapSv-DiGNuFF384leo9mTFDo8EU',
			'secret_key'   => 'EBTnLbKT-cCBLpmHAu3QIaAa76Qkz8qxZtXp1Ew8Msldrofp79mamvszCeYEnmZhxvOoR3kJwRNooKA4',
			'access_token' => 'A21AAJM6Vt_oWQNjVwf3rLKOOodGZgXcvueXcwdDhnLQwKkFr4ZK-E6FkaxfRMNgQK8EIJDqmGJB_sHF2Mwv9UNesiN4XkiFg',
			'environment'  => 'sandbox'
		] );
		$client->registerExpiredTokenHandler( [ $this, 'fetchNewToken' ] );

		return $client;
	}

	/**
	 * @param PayPalClient $client
	 */
	public function fetchNewToken( $client ) {
		$token = $client->auth->refresh();
		$client->setAccessToken( $token->access_token );
	}
}