<?php


class OrderTest extends \php\BaseTest {

	public function testCreateOrder() {

		try {
			$order = $this->getClient()->orders->create( [
				"intent"         => \PaymentPlugins\PayPalSDK\Order::CAPTURE,
				"purchase_units" => [
					[
						"amount" => [
							"currency_code" => "USD",
							"value"         => "100.00"
						]
					]
				]
			] );

			return $this->assertIsObject( $order );
		} catch ( \PaymentPlugins\PayPalSDK\Exception\ApiException $e ) {
			return false;
		}
	}


	public function getOrderResponse() {
		$contents = file_get_contents( dirname( __DIR__ ) . '/data/order.json' );

		return [ [ json_decode( $contents, true ) ] ];
	}
}